Index: code/branches/gamestates2/data/gui/scripts/AudioMenu.lua
===================================================================
--- code/branches/gamestates2/data/gui/scripts/AudioMenu.lua	(revision 6718)
+++ code/branches/gamestates2/data/gui/scripts/AudioMenu.lua	(revision 6720)
@@ -3,5 +3,5 @@
 local P = createMenuSheet("AudioMenu")
 
-function P.init()
+function P.onLoad()
     soundMgr = orxonox.SoundManager:getInstance()
     block = false
Index: code/branches/gamestates2/data/gui/scripts/GUISheet.lua
===================================================================
--- code/branches/gamestates2/data/gui/scripts/GUISheet.lua	(revision 6718)
+++ code/branches/gamestates2/data/gui/scripts/GUISheet.lua	(revision 6720)
@@ -13,6 +13,5 @@
 
 -- Override this function if you need to do work on load
--- TODO: rename to onLoad
-function P:init()
+function P:onLoad()
 end
 
@@ -38,5 +37,5 @@
     self:hide()
     -- Allow sheets to do some work upon loading
-    self:init()
+    self:onLoad()
     return self
 end
Index: code/branches/gamestates2/data/gui/scripts/GameplayMenu.lua
===================================================================
--- code/branches/gamestates2/data/gui/scripts/GameplayMenu.lua	(revision 6718)
+++ code/branches/gamestates2/data/gui/scripts/GameplayMenu.lua	(revision 6720)
@@ -3,5 +3,5 @@
 local P = createMenuSheet("GameplayMenu")
 
-function P.init()
+function P.onLoad()
     dropdown = winMgr:getWindow("orxonox/ThemeCombobox")
     local themeList = {}
Index: code/branches/gamestates2/data/gui/scripts/GraphicsMenu.lua
===================================================================
--- code/branches/gamestates2/data/gui/scripts/GraphicsMenu.lua	(revision 6718)
+++ code/branches/gamestates2/data/gui/scripts/GraphicsMenu.lua	(revision 6720)
@@ -3,5 +3,5 @@
 local P = createMenuSheet("GraphicsMenu")
 
-function P.init()
+function P.onLoad()
     block = true
     file = orxonox.PathConfig:getConfigPathString() .. orxonox.getConfig("GraphicsManager", "ogreConfigFile_")
Index: code/branches/gamestates2/data/gui/scripts/KeyBindMenu.lua
===================================================================
--- code/branches/gamestates2/data/gui/scripts/KeyBindMenu.lua	(revision 6718)
+++ code/branches/gamestates2/data/gui/scripts/KeyBindMenu.lua	(revision 6720)
@@ -3,5 +3,5 @@
 local P = createMenuSheet("KeyBindMenu")
 
-function P.init()
+function P.onLoad()
 
     commandList = {}
Index: code/branches/gamestates2/data/gui/scripts/MouseControlsMenu.lua
===================================================================
--- code/branches/gamestates2/data/gui/scripts/MouseControlsMenu.lua	(revision 6718)
+++ code/branches/gamestates2/data/gui/scripts/MouseControlsMenu.lua	(revision 6720)
@@ -3,5 +3,5 @@
 local P = createMenuSheet("MouseControlsMenu")
 
-function P.init()
+function P.onLoad()
     block = false
     mousenormalscrollbarwindow = tolua.cast(winMgr:getWindow("orxonox/MouseNormalScrollbar"),"CEGUI::Scrollbar")
Index: code/branches/gamestates2/data/gui/scripts/MultiplayerMenu.lua
===================================================================
--- code/branches/gamestates2/data/gui/scripts/MultiplayerMenu.lua	(revision 6718)
+++ code/branches/gamestates2/data/gui/scripts/MultiplayerMenu.lua	(revision 6720)
@@ -3,5 +3,5 @@
 local P = createMenuSheet("MultiplayerMenu")
 
-function P.init()
+function P.onLoad()
     listbox = winMgr:getWindow("orxonox/MultiplayerLevelListbox")
     preselect = orxonox.LevelManager:getInstance():getDefaultLevel()
Index: code/branches/gamestates2/data/gui/scripts/SingleplayerMenu.lua
===================================================================
--- code/branches/gamestates2/data/gui/scripts/SingleplayerMenu.lua	(revision 6718)
+++ code/branches/gamestates2/data/gui/scripts/SingleplayerMenu.lua	(revision 6720)
@@ -3,5 +3,5 @@
 local P = createMenuSheet("SingleplayerMenu")
 
-function P.init()
+function P.onLoad()
     listbox = winMgr:getWindow("orxonox/SingleplayerLevelListbox")
     preselect = orxonox.LevelManager:getInstance():getDefaultLevel()